<?php
/**
* @author     stepFORM <team@stepform.io>
* @date       30/08/2019
* @copyright  Copyright (C) 2019 stepFORM. All rights reserved.
* @license    GNU General Public License version 2 or later; see LICENSE
*/

defined('_JEXEC') or die;

class stepFORMCore
{

    /**
    * Retrieving form data
    * @var string
    */
    const FORM_URL = 'https://stepform.io/dev/integration/form';

    /**
    * [protected description]
    * @var [type]
    */
    protected $app;

    /**
    * [protected description]
    * @var [type]
    */
    protected $pluginId;

    /**
    * [protected description]
    * @var [type]
    */
    protected $db;

    /**
    * [protected description]
    * @var [type]
    */
    protected $params;

    /**
    * [protected description]
    * @var [type]
    */
    protected $stepFORMKey;

    /**
    * [protected description]
    * @var [type]
    */
    protected $lang;


    /**
    * Constructor
    */
    public function __construct()
    {
      $this->app = JFactory::getApplication();
      $this->db = JFactory::getDBO();
      $this->lang = JFactory::getLanguage();
      $this->lang->load('plg_content_stepFORM.sys', stepFORM_PluginDir, null, true);
      $this->getId();
      $this->settings_front();
      $this->article_front();
    }

    /**
    * Get id plugins
    *
    */
    private function getId()
    {
      $query = 'SELECT extension_id, params FROM #__extensions
      WHERE folder ="' . $this->db->escape(stepFORM_PluginType) . '" AND
      element ="' . $this->db->escape(stepFORM_PluginName) . '"';

      $this->db->setQuery($query);

      if (!($plugin = $this->db->loadObject())) {
        throw new Exception('plugin stepFORM not install');
      } else {
        $this->pluginId = (int)$plugin->extension_id;
        $this->params = json_decode($plugin->params);

        if (isset($this->params->stepFORM_key)) {
          $this->stepFORMKey = $this->params->stepFORM_key;
        }else {
          $this->stepFORMKey = '';
        }
      }
    }

    /**
    * Check plugin status
    *
    */
    protected function checkPluginStatus()
    {
      $query = 'SELECT extension_id, params FROM #__extensions
      WHERE folder ="' . $this->db->escape(stepFORM_PluginType) . '" AND
      element ="' . $this->db->escape(stepFORM_PluginName) . '"';

      $this->db->setQuery($query);
      $plugin = $this->db->loadObject();

      if (!is_null($plugin)) {
        $params = json_decode($plugin->params, true);
        if (json_last_error() !== JSON_ERROR_NONE) {
          return JText::_('PLG_STEPFORM_PLG_ERROR');
        }

        if (isset($params['stepFORM_key']) && !empty($params['stepFORM_key'])) {
          return true;
        } else {
          return JText::_('PLG_STEPFORM_PLG_ERROR_SETTINGS');
        }
      } else {
        return JText::_('PLG_STEPFORM_PLG_NOT_EXIST');
      }
    }

    /**
    * Check settings plugins
    *
    * @return boolean check setting
    */
    private function is_settings()
    {
      if (!$this->app->isAdmin() === true) {
        return false;
      }

      if ($this->app->input->getMethod() === 'GET') {
        if ($this->app->input->getCmd('option') === 'com_plugins' &&
        $this->app->input->getCmd('view') === 'plugin' &&
        (int)$this->app->input->getCmd('extension_id') === $this->pluginId
      ) {
        $this->AddLang();
        return true;
      }
    }

    return false;
  }


    /**
    * Settings frontend
    *
    */
    public function settings_front()
    {
      if ($this->is_settings()) {
        $doc = JFactory::getDocument();
        $style = '/plugins/' . stepFORM_PluginType . '/' . stepFORM_PluginName . '/assets/css/settings_admin.css';
        $doc->addStyleSheet($style);
        $script = '/plugins/' . stepFORM_PluginType . '/' . stepFORM_PluginName . '/assets/js/settings_admin.js';
        $doc->addScript($script);
      }
    }

    /**
    * Article frontend
    *
    */
    public function article_front()
    {
      if ($this->IsInsertFrondButtons()) {
        $doc = JFactory::getDocument();
        $style = '/plugins/' . stepFORM_PluginType . '/' . stepFORM_PluginName . '/assets/css/edit_button.css';
        $doc->addStyleSheet($style);
        $script = '/plugins/' . stepFORM_PluginType . '/' . stepFORM_PluginName . '/assets/js/edit_button.js';
        $doc->addScript($script);
      }
    }

    /**
    * Check article
    *
    * @return boolean check article
    */
    public function is_article()
    {
      if ($this->app->input->getMethod() === 'GET') {
        if ($this->app->input->getCmd('option') === 'com_content' &&
        ($this->app->input->getCmd('view') === 'article' ||
        $this->app->input->getCmd('view') === 'form') &&
        $this->app->input->getCmd('layout') === 'edit'
      ) {
        return true;
      }
    }

    return false;
    }

    /**
    * Check is module edit admin
    *
    * @return boolean check editor
    */
    public function is_module_edit_admin()
    {
      if ($this->app->input->getMethod() === 'GET') {
        if ($this->app->input->getCmd('option') === 'com_modules' &&
        $this->app->input->getCmd('view') === 'module' &&
        $this->app->input->getCmd('layout') === 'edit'
      ) {
        return true;
      }
    }
    return false;
    }


    /**
    * Check is module edit client
    *
    * @return boolean check editor
    */
    public function is_module_edit_client()
    {
      if ($this->app->input->getMethod() === 'GET') {
        if ($this->app->input->getCmd('option') === 'com_config' &&
        $this->app->input->getCmd('controller') === 'config.display.modules'
      ) {
        return true;
      }
    }
    return false;
    }

    /**
    * IsInsertFrondButtons
    */
    private function IsInsertFrondButtons()
    {
      $is_aticle = $this->is_article();
      $is_admin = $this->is_module_edit_admin();
      $is_client = $this->is_module_edit_client();

      if ($is_aticle || $is_admin || $is_client) {
        $this->AddLang();
        return true;
      }
      return false;
    }


    /**
    * Get all user forms
    */
    protected function UserAllForms()
    {
      $headers = array(
        'application/x-www-form-urlencoded'
      );
      $data = array('token' => $this->stepFORMKey);
      $forms = json_decode($this->SendRequest(self::FORM_URL, $data, $headers), true);

      if (json_last_error() !== JSON_ERROR_NONE) {
        return array();
      }

      if ($forms) {
        foreach ($forms as $key => $row) {
          $forms[$key]['form_id'] = htmlspecialchars($row['form_id']);
          $forms[$key]['form_screen'] = htmlspecialchars($row['form_screen']);
          $forms[$key]['form_name'] = htmlspecialchars($row['form_name']);
        }
      }
      return $forms;
    }

    /**
    * Submitting a form request
    *
    * @param srting  $url     Request Address
    * @param array  $data    Request Data
    * @param array  $headers Request header
    * @param integer $timeout Request break time
    */
    protected function SendRequest($url, $data, $headers, $timeout = 0)
    {
      if (JHttpTransportCurl::isSupported()) {
        $headers = array(
          'Content-Type' => 'application/x-www-form-urlencoded'
        );

        $registry = new Joomla\Registry\Registry();
        $get = JHttpFactory::getHttp($registry);
        $get->setOption(CURLOPT_POST, 1);
        $get->setOption(CURLOPT_POSTFIELDS, $data);
        $get->setOption(CURLOPT_RETURNTRANSFER, 1);
        $res = $get->post($url, $data, $headers);

        if ($res->code === 200) {
          return $res->body;
        }
      }
      return false;
    }

    /**
    * Get content status
    *
    */
    private function StatusConnect()
    {
      $headers = array(
        'application/x-www-form-urlencoded'
      );

      $data = array(
        'token' => $this->stepFORMKey
      );

      if ($this->SendRequest(self::FORM_URL, $data, $headers)) {
        return true;
      }
      return false;
    }

    /**
    * Add language
    *
    */
    private function AddLang()
    {
      $files = $this->lang->getPaths('plg_content_stepFORM.sys');
      $locale = $this->lang->getTag();

      $lang_file = key($files);
      foreach ($files as $file => $row) {
        $pattern = preg_quote($locale);
        if (preg_match('~' . $pattern . '~iu', $file)) {
          $lang_file = $file;
          break;
        }
      }

      $locale = $this->lang->getTag();

      if (preg_match('~-~iu', $locale)) {
        $locale = explode('-', $locale);
        $locale = $locale['0'];
      } else {
        $locale = 'en';
      }

      $data = array(
        'lang' => parse_ini_file($lang_file),
        'thisLang' => $locale,
        'connect' => $this->StatusConnect()
      );

      $doc = JFactory::getDocument();
      $doc->addScriptDeclaration('var stepFORMPlugin = ' . json_encode($data) . ' ;');
    }
}
