<?php
/**
* @author     stepFORM <team@stepform.io>
* @date       30/08/2019
* @copyright  Copyright (C) 2019 stepFORM. All rights reserved.
* @license    GNU General Public License version 2 or later; see LICENSE
*/
defined('_JEXEC') or die;

class pkg_stepFORMInstallerScript
{

  /**
  * Constructor
  *
  * @param   JAdapterInstance $adapter The object responsible for running this script
  */
  public function __construct(JAdapterInstance $adapter)
  {

  }

  /**
  * Called before any type of action
  *
  * @param   string $route Which action is happening (install|uninstall|discover_install|update)
  * @param   JAdapterInstance $adapter The object responsible for running this script
  *
  * @return  boolean  True on success
  */
  public function preflight($route, JAdapterInstance $adapter)
  {

  }

  /**
  * Called after any type of action
  *
  * @param   string $route Which action is happening (install|uninstall|discover_install|update)
  * @param   JAdapterInstance $adapter The object responsible for running this script
  *
  * @return  boolean  True on success
  */
  public function postflight($route, JAdapterInstance $adapter)
  {
    if (file_exists(JPATH_ADMINISTRATOR . '/manifests/packages/stepFORM')) {
      $files = scandir(JPATH_ADMINISTRATOR . '/manifests/packages/stepFORM');
      $files = array_diff($files, array('.', '..'));

      if (!empty($files)) {
        foreach ($files as $file) {
          unlink(JPATH_ADMINISTRATOR . '/manifests/packages/stepFORM/' . $file);
        }
      }
      rmdir(JPATH_ADMINISTRATOR . '/manifests/packages/stepFORM');
    }
    if (file_exists(JPATH_ADMINISTRATOR . '/manifests/packages/pkg_stepFORM.xml')) {
      unlink(JPATH_ADMINISTRATOR . '/manifests/packages/pkg_stepFORM.xml');
    }
  }

  /**
  * Called on installation
  *
  * @param   JAdapterInstance $adapter The object responsible for running this script
  *
  */
  public function install(JAdapterInstance $adapter)
  {
    $database = JFactory::getDbo();
    $query = $database->getQuery(true);
    $query->delete('#__extensions');
    $query->where($database->quoteName('element') . ' = ' . $database->quote('pkg_stepFORM'));
    $query->where($database->quoteName('type') . ' = ' . $database->quote('package'));
    $database->setQuery($query);
    $database->execute();

    $this->stepFORM_id();
    $query = $database->getQuery(true);
    $query->update('#__extensions');
    $query->set($database->quoteName('enabled') . ' = 1');
    $query->where($database->quoteName('element') . ' = ' . $database->quote('stepFORM'));
    $database->setQuery($query);
    $database->execute();
  }

  public function stepFORM_id()
  {
    $database = JFactory::getDBO();
    $query = 'SELECT extension_id, params FROM #__extensions
    WHERE folder ="content" AND
    element ="stepFORM"';
    $database->setQuery($query);

    if (($plugin = $database->loadObject())) {
      $language = JFactory::getLanguage();
      $language->load('plg_content_stepFORM.sys', JPATH_PLUGINS . '/content/stepFORM', null, true);

      echo '<img src="https://stepform.io/static/integration-banner.png">';
      echo '<div style="padding: 30px;font-size: 15px;line-height: 25px;font-weight: bolder;">' .
      $language->_('PLG_INSTALL_MESSAGE') .
      ' <a href=' . JURI::base() . 'index.php?option=com_plugins&task=plugin.edit&extension_id=' . (int)$plugin->extension_id
      . '">' . $language->_('PLG_INSTALL_MESSAGE_LINK') . '</a>.</div>';
    }
  }

  /**
  * Called on update
  *
  * @param   JAdapterInstance $adapter The object responsible for running this script
  *
  * @return  boolean  True on success
  */
  public function update(JAdapterInstance $adapter)
  {


  }

  /**
  * Called on uninstallation
  *
  * @param   JAdapterInstance $adapter The object responsible for running this script
  */
  public function uninstall(JAdapterInstance $adapter)
  {

  }

}
