<?php
/**
* @author     stepFORM <team@stepform.io>
* @date       30/08/2019
* @copyright  Copyright (C) 2019 stepFORM. All rights reserved.
* @license    GNU General Public License version 2 or later; see LICENSE
*/

defined('_JEXEC') or die;

class PlgContentstepFORMInstallerScript
{
  /**
  * Constructor
  *
  * @param   JAdapterInstance $adapter The object responsible for running this script
  */
  public function __construct(JAdapterInstance $adapter)
  {

  }

  /**
  * Called before any type of action
  *
  * @param   string $route Which action is happening (install|uninstall|discover_install|update)
  * @param   JAdapterInstance $adapter The object responsible for running this script
  *
  * @return  boolean  True on success
  */
  public function preflight($route, JAdapterInstance $adapter)
  {

  }

  /**
  * Called after any type of action
  *
  * @param   string $route Which action is happening (install|uninstall|discover_install|update)
  * @param   JAdapterInstance $adapter The object responsible for running this script
  *
  * @return  boolean  True on success
  */
  public function postflight($route, JAdapterInstance $adapter)
  {

  }

  /**
  * Called on installation
  *
  * @param   JAdapterInstance $adapter The object responsible for running this script
  *
  */
  public function install(JAdapterInstance $adapter)
  {
    $database = JFactory::getDbo();
    $query = $database->getQuery(true);

    $query->update('#__extensions');
    $query->set($database->quoteName('enabled') . ' = 1');
    $query->where($database->quoteName('element') . ' = ' . $database->quote('stepFORM'));
    $query->where($database->quoteName('folder') . ' = ' . $database->quote('content'));
    $database->setQuery($query);
    $database->execute();
  }

  /**
  * Called on update
  *
  * @param   JAdapterInstance $adapter The object responsible for running this script
  *
  * @return  boolean  True on success
  */
  public function update(JAdapterInstance $adapter)
  {

  }

  /**
  * Called on uninstallation
  *
  * @param   JAdapterInstance $adapter The object responsible for running this script
  */
  public function uninstall(JAdapterInstance $adapter)
  {

  }

  /**
  * Render post installation
  */
  public function renderPostInstallation()
  {

  }
}
