<?php
/**
* @author     stepFORM <team@stepform.io>
* @date       30/08/2019
* @copyright  Copyright (C) 2019 stepFORM. All rights reserved.
* @license    GNU General Public License version 2 or later; see LICENSE
*/
defined('_JEXEC') or die;


class PlgButtonstepFORM extends JPlugin
{

  /**
  * Load the language file on instantiation.
  * @var boolean
  */
  protected $autoloadLanguage = true;


  /**
  * Display the button
  *
  * @param   string $name The name of the button to add
  * @return  JObject  The button options as JObject
  * @since   1.0.0
  */
  public function onDisplay($name)
  {
    $user = JFactory::getUser();

    if (!$this->stepFORM_PluginCheck()) {
      return;
    }

    if ($user->authorise('core.create', 'com_contact')
    || $user->authorise('core.edit', 'com_contact')
    || $user->authorise('core.edit.own', 'com_contact')) {
      $link = 'index.php?option=com_ajax&amp;plugin=stepFORM&amp;format=html&amp;group=content&amp;method=AllForms';

      $btn = new JObject;
      $btn->modal = true;
      $btn->class = 'btn';
      $btn->link = $link;
      $btn->text = JText::_('stepFORM');
      $btn->name = 'mce-i-stepform-ico';
      $btn->options = "{handler: 'iframe', size: {x: 400, y: 100}}";

      $document = JFactory::getDocument();
      $css = '.icon-mce-i-stepform-ico {' .
        'background: url(https://stepform.io/favicon.png) no-repeat center !important;' .
        'background-size: 16px !important;' .
        'margin-top: 1px !important;' .
        'margin-right: 2px !important;' .
        '} ';

        $document->addStyleDeclaration($css);

        return $btn;
      }
    }

    /**
    * Plugin check function
    * @return boolean
    */
    private function stepFORM_PluginCheck()
    {
      $database = JFactory::getDBO();
      $query = 'SELECT extension_id, params FROM  #__extensions
      WHERE folder ="' . $database->escape('content') . '" AND
      element ="' . $database->escape('stepFORM') . '" and enabled like "1"';

      $database->setQuery($query);
      $plugins = $database->loadObject();

      if (!is_null($plugins)) {
        return true;
      }

      return false;
    }
  }
